
QGIS Application - Bug report #14255

SVG preview blocks QGIS

2016-02-09 05:01 AM - Paolo Cavallini

Status: Closed

Priority: Severe/Regression

Assignee: Nyall Dawson

Category: Symbology

Affected QGIS version:master Regression?: No

Operating System: Debian Easy fix?: No

Pull Request or Patch supplied:No Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 22251

Description

When changing a symbol to SVG, or in other instances where SVG preview should be created in vector properties, QGIS takes 100% of

CPU, and the system lags for ages, even on a modern machine.

Associated revisions

Revision c60c4f7f - 2016-10-04 06:55 AM - Nyall Dawson

Fix SVG preview blocks QGIS (fix #14255)

Now SVG preview loading occurs in a background thread so that

dialogs can open instantly

Revision 0b683637 - 2016-10-04 11:22 AM - Nyall Dawson

Merge pull request #3565 from nyalldawson/svg_background

Fix SVG preview blocks QGIS (fix #14255)

Revision ffafafdb - 2016-10-06 01:09 PM - Nyall Dawson

Fix SVG preview blocks QGIS (fix #14255)

Now SVG preview loading occurs in a background thread so that

dialogs can open instantly

Also guard against circular symbolic links in SVG selector widget

(cherry-picked from c60c4f7f0ca09dc6bbc8e3f721339a238154ff57)

Revision bb2450ee - 2016-10-06 01:49 PM - Nyall Dawson

Fix SVG preview blocks QGIS (fix #14255)

Now SVG preview loading occurs in a background thread so that

dialogs can open instantly
Also guard against circular symbolic links in SVG selector widget

(cherry-picked from c60c4f7f0ca09dc6bbc8e3f721339a238154ff57)

History

#1 - 2016-02-09 06:14 AM - Richard Duivenvoorde

Hi Paolo,

can you provide more details to reproduce?

I'm here on Debian testing, but can perfectly fine load a point layer and select one of the svg symbols for it.

#2 - 2016-02-09 01:03 PM - Giovanni Manghi

- Status changed from Open to Feedback

No problems whatsoever on master on both Ubuntu and Windows. Please try another system and report back. Thanks.

#3 - 2016-02-10 12:20 AM - Paolo Cavallini

Thanks for the feedback. In this case a packaging/dependency problem seems likely. Anyone on sid?

#4 - 2016-02-10 01:15 AM - Giovanni Manghi

Paolo Cavallini wrote:

Thanks for the feedback. In this case a packaging/dependency problem seems likely. Anyone on sid?

If I'm not wrong Richard is on sid, and this would suggest a local issue.

#5 - 2016-02-11 09:11 AM - Paolo Cavallini

Richard is on testing

#6 - 2016-02-11 10:56 AM - Giovanni Manghi

Paolo Cavallini wrote:

Richard is on testing

have you tried other machines?

#7 - 2016-03-14 06:35 PM - Nyall Dawson
Paolo- can I close this? No-one else is able to reproduce this issue.

#8 - 2016-03-14 11:33 PM - Paolo Cavallini

- Status changed from Feedback to Closed

- Resolution set to worksforme

OK, thanks

#9 - 2016-07-04 01:24 AM - Jorge Rocha

- Status changed from Closed to Reopened

- File SVG_recursive_search_fails_with_circular_links.png added

Hi,

This same behavior is happening on 2.14.3 on Ubuntu.

After waiting several minutes for the dialog with the SVG symbols, with the CPU at 100%, I found out the following:

- QGIS is following symbolic links recursively to find SVG symbols to show on the dialog.

There are 3 SVG groups on the style dialog:

- jgr (my account)

- App Symbols

- User Symbols

The problem happens with symbols found in my account.

The path of a symbol, for example, is:

/home/jgr/WebstormProjects/MyDashBoard/server/public/server/public/server/public/server/public/server/public/server/public/server/public/server/public/

erver/public/server/public/server/public/server/public/server/public/server/public/server/public/server/public/server/public/server/public/server/public/server/public/server/public/server/public/server/public/server/public/server/public/server/public/server/public/server/public/server/public/server/public/se

r/public/server/public/server/public/server/public/server/public/server/public/server/public/server/public/server/public/server/public/server/public/server/public/server/public/server/public/server/public/server/public/server/public/server/public/server/public/server/public/server/public/server/node_modules/dns/public/css/fonts/glyphicons-halflings-regular.svg

blic/server/public/server/public/server/public/server/public/server/public/server/public/server/public/server/public/server/public/server/node_modules/dns/public/css/fonts/glyphicons-halflings-regular.svg

ublic/css/fonts/glyphicons-halflings-regular.svg

In my case, in /home/jgr/WebstormProjects/MyDashBoard/server/public I have a symbolic link 'public' pointing to '..'.

I think we need to prevent that the search algorithm does not transverses that same link again.

#10 - 2016-07-04 01:30 AM - Jorge Rocha

Since the user can edit the SVG path (Settings → Options → System → SVG Path), if I remove the folder with circular links, the problem disappears.

#11 - 2016-07-05 10:26 PM - Andreas Neumann

Paolo: I wonder if your issue is the same? Can you please check if there are any circular symbolic links in your SVG paths?

I cannot replicate the issue on Ubuntu 16.04 and self compiled master. But I have no symbolic links in my SVG paths ...

2024-03-20 3/4



#12 - 2016-07-05 10:26 PM - Andreas Neumann

- Status changed from Reopened to Feedback

#13 - 2016-07-05 10:45 PM - Paolo Cavallini

No circular ref here.

#14 - 2016-07-05 11:34 PM - Giovanni Manghi

- Status changed from Feedback to Open

- Resolution deleted (worksforme)

#15 - 2016-07-25 12:29 AM - Andreas Neumann

Why is this bug still open? Apparently the issue with the accidental home folder is fixed in master and 2.16 and if a user is still affected (s)he can easily

remove the home folder from the settings.

Not a big issue in my opinion and we should close this bug.

#16 - 2016-07-25 03:33 AM - Nyall Dawson

I still think this needs to be properly addressed, and make the svg preview run in a non blocking thread.

#17 - 2016-10-03 02:18 AM - Nyall Dawson

- Assignee set to Nyall Dawson

#18 - 2016-10-03 10:48 PM - Nyall Dawson

PR at https://github.com/qgis/QGIS/pull/3565 - also fixes the circular symlink issue.

#19 - 2016-10-04 02:23 AM - Nyall Dawson

- Status changed from Open to Closed

Fixed in changeset commit:"0b683637896f552b13f419f1fcabb9fe9fa2fdea".

Files

SVG_recursive_search_fails_with_circular_links.png 147 KB 2016-07-03 Jorge Rocha
https://github.com/qgis/QGIS/pull/3565

